/*
** isc_abort.c                                  Route to handle fatal errors
**
** Copyright (c) 1991, 1992, 1993 Peter Eriksson and Per Cederqvist of the
**                    Lysator Academic Computer Association.
**
** history:
** 910305 pen      moved into separate file
*/

#include <stdio.h>
#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif
#ifdef HAVE_STDDEF_H
#  include <stddef.h>
#endif
#ifdef HAVE_STDARG_H
#  include <stdarg.h>
#endif
#include <sys/types.h>
#include <sys/socket.h>
#include <time.h>

#include "isc.h"
#include "intern.h"

static void (*isc_abortfn)(const char *msg) = NULL;

  
void
isc_setabortfn(void (*abortfn)(const char *msg))
{
  isc_abortfn = abortfn;
}


void
isc_abort(const char *message)
{
  if (isc_abortfn)
    (*isc_abortfn)(message);
  else
  {
    fprintf(stderr, "\n\r*** ISC SUBSYSTEM FATAL ERROR: %s\n\r", message);
    abort();
  }
}
  
