/*
 * $Id: log.c,v 0.13 1994/08/19 22:04:55 ceder Exp $
 * Copyright (C) 1991, 1992, 1993, 1994  Lysator Academic Computer Association.
 *
 * This file is part of the LysKOM server.
 * 
 * LysKOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 1, or (at your option) 
 * any later version.
 * 
 * LysKOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with LysKOM; see the file COPYING.  If not, write to
 * Lysator, c/o ISY, Linkoping University, S-581 83 Linkoping, SWEDEN,
 * or the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, 
 * MA 02139, USA.
 *
 * Please mail bug reports to bug-lyskom@lysator.liu.se. 
 */
/*
 * log.c
 *
 * File created by ceder 1990-05-25.
 */

static char *rcsid = "$Id: log.c,v 0.13 1994/08/19 22:04:55 ceder Exp $";
#include "rcs.h"
USE(rcsid);

#ifdef HAVE_STDARG_H
#  include <stdarg.h>
#endif
#include <stdio.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>

#include "log.h"

/*
 * Add a string to the log file.
 */

#if defined(HAVE_VFPRINTF) && defined(HAVE_STDARG_H)
extern void
log (const char * format, ...)
{
    va_list AP;

    va_start(AP, format);
    logv(format, AP);
    va_end(AP);
}


extern void
logv (const char *format, va_list AP)
{
    time_t clock;
    struct tm *t;

    time(&clock);
    t = localtime(&clock);

    fprintf(stderr, "%02d%02d%02d %02d:%02d:%02d %d ",
	    t->tm_year, t->tm_mon + 1, t->tm_mday,
	    t->tm_hour, t->tm_min, t->tm_sec, getpid());
    vfprintf(stderr, format, AP);

    fflush(stderr);
}
#else  /* !HAVE_VFPRINTF */
extern void
log (const char * format, 
     int a, int b, int c, int d, int e, int f, int g)
{
    time_t clock;
    struct tm *t;

    time(&clock);
    t = localtime(&clock);

    fprintf(stderr, "%02d%02d%02d %02d:%02d:%02d %d ",
	    t->tm_year, t->tm_mon + 1, t->tm_mday,
	    t->tm_hour, t->tm_min, t->tm_sec, getpid());
    fprintf(stderr, format, a, b, c, d, e, f, g);

    fflush(stderr);
    
}
#endif /* !HAVE_VFPRINTF */
